function [QP,QV,QF,QFit]=NSGA2POX(p_chrom,v_chrom,f_chrom,fitness,Pc,Pm,ps)
% global ps N;
[Pool_P,Pool_V,Pool_F,Pool_Fit]=TSelection(p_chrom,v_chrom,f_chrom,fitness,ps);
CP=[];CF=[];CV=[];CFit=[];
% tot=sum(1:N);
for i=1:ps
    if rand<Pc
        index=ceil(rand*ps);
        P1=Pool_P(index,:);
        V1=Pool_V(index,:,:);
        F1=Pool_F(index,:);
        [np1,np2]=POX(p_chrom(i,:),P1);
        [nv1,nv2]=UX_V(v_chrom(i,:,:),V1);
        [nf1,nf2]=UX_F(f_chrom(i,:),F1);
%         if sum(np1)~=tot ||sum(np2)~=tot
%             fprintf('PMX wrong sum(np1)=%d sum(np2)=%d\r\n',sum(np1),sum(np2));
%         end
        if rand<Pm
            np1=muation_p(np1);
            nv1=muation_v(nv1);
            nf1=muation_f(nf1);
        end
        if rand<Pm
            np2=muation_p(np2);
            nv2=muation_v(nv2);
            nf2=muation_f(nf2);
        end
    end
%     [f1]=FitPFSP(np1);
%     [f2]=FitPFSP(np2);
    fit1=zeros(1,3);fit2=zeros(1,3);
    [np1,nv1,nf1]=Repair(np1,nv1,nf1);
    [np2,nv2,nf2]=Repair(np2,nv2,nf2);
    [fit1(1,1),fit1(1,2),fit1(1,3)]=FitDHWSP(np1,nv1,nf1);
    [fit2(1,1),fit2(1,2),fit2(1,3)]=FitDHWSP(np2,nv2,nf2);

    CP=[CP;np1;np2];CF=[CF;nf1;nf2]; %Ⱥ
    CV=[CV;nv1;nv2];CFit=[CFit;fit1;fit2]; %Ⱥ
end
QP=[];QF=[];QV=[];QFit=[];
QP=[p_chrom;CP];QF=[f_chrom;CF];
QV=[v_chrom;CV];QFit=[fitness;CFit];
[QP,QV,QF,QFit]=DeleteRpeatQF(QP,QV,QF,QFit);
end

function [np,nv,nf]=Repair(np,nv,nf)
global NS NM N;

for i=1:N
    f_index=nf(1,i);
    for s=1:NS
        if nv(1,i,s)>NM(f_index,s)
            nv(1,i,s)=NM(f_index,s);
        end
    end   
end
end

function [AP,AV,AF,AFit]=DeleteRpeatQF(AP,AV,AF,AFit)
global ps;
[m,~]=size(AFit);
for i=1:m
    if i>m
        break;
    end
    F=AFit(i,:);
    j=i+1;
    while j<m
        if AFit(j,1)==F(1,1)&&AFit(j,2)==F(1,2)
            AP(j,:)=[];
            AV(j,:,:)=[];
            AF(j,:)=[];   
            AFit(j,:)=[]; 
            j=j-1;
            m=m-1;
            if m<ps*2+1 %֤ 2*psѡ
                break;
            end
        end
        j=j+1;
    end
          if m<ps*2+1 %֤ 2*psѡ
                break;
          end
end
end

%two point swap mutation
function [p_chrom]=muation_p(p_chrom)
global N;
pos1=ceil(rand*N);
pos2=ceil(rand*N);
while pos1==pos2
    pos2=ceil(rand*N);
end
temp=p_chrom(pos1);
p_chrom(pos1)=p_chrom(pos2);
p_chrom(pos2)=temp;
end

%randomly reselect a speed
function [v_chrom]=muation_v(v_chrom)
global N TM;
row=ceil(rand*N);
col=ceil(rand*TM);
v_chrom(1,row,col)=ceil(rand*5);
end

%randomly reselect a factory
function [f_chrom]=muation_f(f_chrom)
global N F;
pos1=ceil(rand*N);
cf=f_chrom(pos1);
f=ceil(rand*F);
while cf==f
    f=ceil(rand*F);
    f_chrom(pos1)=f;
end
f_num=zeros(1,F);
for f=1:F
    f_num(1,f)=length(find(f_chrom==f));
end

for f=1:F
    if f_num(1,f)==0
        FChrom=zeros(1,N);
for i=1:N
    FChrom(i)=mod(i,F);%0ʾֵ1,1ʾֵ2 ߷ǲһĹĻһġ
    if FChrom(i)==0
       FChrom(i)=F;
    end       
end
%         fprintf('factory %d is zeros 1',f)
        f_chrom=FChrom(randperm(N));%
    end
end

end

%universial crossover operator (UX) for speed 
function [nv1,nv2]=UX_V(V1,V2)
    global N TM;
    nv1=V1;nv2=V2;
    for i=1:N
        for k=1:TM
            r=round(rand*1);
            if r==1
                temp=nv1(1,i,k);
                nv1(1,i,k)=nv2(1,i,k);
                nv2(1,i,k)=temp;
            end
        end
    end
end

function [nf1,nf2]=UX_F(F1,F2)
    global N F;
    nf1=F1;nf2=F2;
    for i=1:N
        r=round(rand*1);
        if r==1
           temp=nf1(i);
           nf1(i)=nf2(i);
           nf2(i)=temp;
        end
    end
%check nf1
f_num=zeros(1,F);
for f=1:F
    f_num(1,f)=length(find(nf1==f));
end

for f=1:F
    if f_num(1,f)==0
%         fprintf('factory %d is zeros 2',f)
FChrom=zeros(1,N);
for i=1:N
    FChrom(i)=mod(i,F);%0ʾֵ1,1ʾֵ2 ߷ǲһĹĻһġ
    if FChrom(i)==0
       FChrom(i)=F;
    end       
end
        nf1=FChrom(randperm(N));%
    end
end

%check nf2
f_num=zeros(1,F);
for f=1:F
    f_num(1,f)=length(find(nf2==f));
end

for f=1:F
    if f_num(1,f)==0
%         fprintf('factory %d is zeros 3',f)
FChrom=zeros(1,N);
for i=1:N
    FChrom(i)=mod(i,F);%0ʾֵ1,1ʾֵ2 ߷ǲһĹĻһġ
    if FChrom(i)==0
       FChrom(i)=F;
    end       
end
        nf2=FChrom(randperm(N));%
    end
end

end
%partially matching crossover operator (PMX) 1985
function [np1,np2]=PMX(P1,P2)
global N;
pos1=ceil(N/ 2 - N/ 4);
pos2=ceil(N-pos1);
L=min(pos1,pos2);
U=max(pos1,pos2);
np1=zeros(1,N);
np2=zeros(1,N);

part1=P1(1,L:U);
part2=P2(1,L:U);

np1=P1;
np2=P2;

np1(1,L:U)=part2;
np2(1,L:U)=part1;

l=length(part1);

    for j=1:N
        if j<L || j>U
            x=find(part2==np1(j), 1);
            if ~isempty(x)
                np1(j)=part1(x);
                x=find(part2==np1(j), 1);
                while ~isempty(x)
                    np1(j)=part1(x);
                    x=find(part2==np1(j), 1);
                end
            end
            
            x2=find(part1==np2(j), 1);
            if ~isempty(x2)
                np2(j)=part2(x2);
                x2=find(part1==np2(j), 1);
                while ~isempty(x2)
                    np2(j)=part2(x2);
                    x2=find(part1==np2(j), 1);
                end
            end
        end
    end

end

function [np1,np2]=POX(P1,P2)
global N;
np1=P1;
np2=P2;

J1=[];%ڴ洢idļ0ʾQ1 1ʾQ2
c1_p=zeros(1,N);%ڱp1Q1idλ
c2_p=zeros(1,N);%ڱp2Q1idλ

while size(J1,1)==0 && size(J1,2)==0
    J1=find(round(rand(1,N))==1);%idŵļ
end

for j=1:N
    if ismember(np1(j),J1) %P1J1Ԫش洢
        c1_p(j)=np1(j);
    end
    
    if ~ismember(np2(j),J1) %P2вJ1Ԫش洢c2
        c2_p(j)=np2(j);
    end
end

index_1_1=find(c1_p==0);%c1еĿλӦc2з0Ŀλ
index_1_2=find(c2_p~=0);

index_2_1=find(c2_p==0);%c2еĿλӦc2з0Ŀλ
index_2_2=find(c1_p~=0);

for j=1:size(index_1_1,2)%p2
    c1_p(index_1_1(j))=np2(index_1_2(j));
end

for j=1:size(index_2_1,2)
    c2_p(index_2_1(j))=np1(index_2_2(j));
end

np1=c1_p;
np2=c2_p;

end

function [childp,childv,childf,F]=TSelection(p_chrom,v_chrom,f_chrom,fitness,ps)
%ȽѡõĸΪ뽻أֱѡһٸظ
    global N NS;
    SH=N;
    pool_size=ps;%ѡĲصĴС
    tour=2;%뾺Ŀ
    childp=zeros(ps,SH);
    childv=zeros(ps,N,NS);
    childf=zeros(ps,N);
    F=zeros(ps,3);
    for i=1:pool_size
        index1=ceil(rand*ps);
        index2=ceil(rand*ps);%ѡλ
        while index1==index2
            index2=ceil(rand*ps);
        end
        f1=fitness(index1,1:2);
        f2=fitness(index2,1:2);
        if(NDS(f1,f2)==1)
            childp(i,:)=p_chrom(index1,:); 
            childv(i,:,:)=v_chrom(index1,:,:);
            childf(i,:)=f_chrom(index1,:);
            F(i,:)=fitness(index1,:);
        elseif(NDS(f1,f2)==2)
            childp(i,:)=p_chrom(index2,:); 
            childv(i,:,:)=v_chrom(index2,:,:);
            childf(i,:)=f_chrom(index2,:);
            F(i,:)=fitness(index2,:);
        else
            if rand<=0.5
                childp(i,:)=p_chrom(index1,:); 
            childv(i,:,:)=v_chrom(index1,:,:);
            childf(i,:)=f_chrom(index1,:);
            F(i,:)=fitness(index1,:);
            else
                childp(i,:)=p_chrom(index2,:); 
            childv(i,:,:)=v_chrom(index2,:,:);
            childf(i,:)=f_chrom(index2,:);
            F(i,:)=fitness(index2,:);
            end
        end
    end
end

function [TopPSRank]=FastNDS(fitness)
    TopPSRank=[];
    global ps;
    L=size(fitness,1);
    rank=1;
    F(rank).f=[];     %¼pareto⼯ȼΪrankĸ弯
    individual=[];  %ڴűĳ֧ĸ弯
    for i=1:L
        individual(i).n=0;  %nǸi֧ĸ
        individual(i).p=[]; %pǱi֧ĸ弯
    end
    for i=1:L 
        for j=1:L
            dom_less=0;
            dom_equal=0;
            dom_more=0;
            for k=1:2  %жϸij֧ϵ
                if (fitness(i,k)>fitness(j,k))  
                    dom_more = dom_more + 1;
                elseif (fitness(i,k)==fitness(j,k))
                    dom_equal = dom_equal + 1;
                else
                    dom_less = dom_less + 1;
                end
            end
            
            if dom_less == 0 && dom_equal ~= 2 % ˵ij֧䣬Ӧn1
                individual(i).n = individual(i).n + 1;
            elseif dom_more == 0 && dom_equal ~= 2 % ˵i֧j,ji֧ϼ
                individual(i).p = [individual(i).p j];
            end  
        end
        if individual(i).n == 0 %i֧ȼߣڵǰŽ⼯ӦȾɫЯϢ
            F(rank).f = [F(rank).f i];%ȼΪ1ķ֧⼯
        end
    end
    %ĴΪҳȼߵķ֧⼯
    %ĴΪ˸зּ
    while(~isempty(F(rank).f))
        Q=[];               %һfront
        fL=length(F(rank).f);   
        for i=1:fL              %ѭǰ֧⼯еĸ
            if ~isempty(individual(F(rank).f(i)).p)
                pL=length(individual(F(rank).f(i)).p);
                for j=1:pL          %ѭi֧⼯еĸ
                    k=individual(F(rank).f(i)).p(j);%pfi֧jӦ֧1
                    individual(k).n=individual(k).n-1;
                    if individual(k).n==0
                        Q=[Q k];
                    end
                end
            end
        end
        rank=rank+1;
        F(rank).f=Q;
    end
    
    fL=length(F);
    obj=fitness;%иĿ꺯ֵתɵֵ㣬˵ܽӵȺܴԿ
    current_index=0;
    for front=1:(fL-1)%FһԪΪ
        previous_index=current_index+1;%ڱһǰrankȼʼ
        ffL=length(F(front).f);
        y=[];
        for i=1:ffL
			t=F(front).f(i);
            y(i,:)=obj(t,:);
        end
        
        current_index=current_index+i;
        crowd=[];
        crowd=zeros(ffL,2);%ڴĿֵӵ
        for i=1:2
            [sort_based_on_objective,sort_index]=sort(y(:,i));%һǰĿֵ
            fmin=sort_based_on_objective(1);
            fmax=sort_based_on_objective(ffL);
            if ffL==1||fmax==fmin%Ĵ
                for j=1:ffL
                    crowd(j,i)=1;
                end
            else
                for j=1:ffL%ÿúĿֵӵ
                if j==1
                    crowd(sort_index(j),i)=(sort_based_on_objective(2)-sort_based_on_objective(1))/(fmax-fmin);
                elseif j==ffL
                    crowd(sort_index(j),i)=(sort_based_on_objective(j)-sort_based_on_objective(j-1))/(fmax-fmin);
                else
                    crowd(sort_index(j),i)=(sort_based_on_objective(j+1)-sort_based_on_objective(j-1))/(fmax-fmin);
                end
                end
            end
           
        end
        crowd(:,1)=crowd(:,1)+crowd(:,2);
        %ӵԽԽ ԽС˵¶ ӵȴӴС ͬʱ ȺҲ
        tmp=[];sort_index=[];
        tmp=F(front).f;
        [~,sort_index]=sort(crowd(:,1),'descend');%ӵȽ
%         fprintf('%d\r\n',front);
        if ffL<length(sort_index)
            fprintf('%d %d\r\n',ffL,length(sort_index));
        end
        for i=length(sort_index)         
           F(front).f(i)=tmp(sort_index(i)); 
        end
    end
    count=0; 
    for front=1:(fL-1)
      ffL=length(F(front).f);
      for i=1:ffL
        TopPSRank=[TopPSRank,F(front).f(i)]; 
        count=count+1;
        if count==ps
            break;
        end
      end
        if count==ps
            break;
        end
    end

end