clc
clear all

FILENAME={'20J2F5S.txt','20J2F10S.txt','20J3F5S.txt','20J3F10S.txt',...
          '40J2F5S.txt','40J2F10S.txt','40J3F5S.txt','40J3F10S.txt',...
          '60J2F5S.txt','60J2F10S.txt','60J3F5S.txt','60J3F10S.txt',...
          '80J2F5S.txt','80J2F10S.txt','80J3F5S.txt','80J3F10S.txt',...
          '100J2F5S.txt','100J2F10S.txt','100J3F5S.txt','100J3F10S.txt'};
filenum=20;
runtime=1;
global N NS F NM stime ptime ps AP AF AV AFit AFlag;
ps=100;Pc=1.0;Pm=0.2;
Pc=1.0;Pm=0.2;epsilon=0.95;alpha=0.1;gamma=0.9;
DATAPATH='..\DATASET_DHWSP2\';
INSPATH={};
for file=1:filenum
    INSPATH{file}=[DATAPATH,FILENAME{file}];
    if file<10
        id=['0',num2str(file)];
    else
        id=num2str(file);
    end
    RESPATH{file}=['DHWSP',id,'\'];
end

for file=1:filenum
    [N,NS,F,NM,stime,ptime]=DATAREAD_DHWSP(INSPATH{file});
    MaxNFEs=400*N;%最大评价次数
    if MaxNFEs<20000
        MaxNFEs=20000;
    end 
    respath='EMTMA\';
    tmp6='\';
    respath=[respath,RESPATH{file},tmp6];
    %清除无关变量
    clear tmp6
    a=['mkdir ' respath];%创立写结果的文件夹
    system(a);%利用Windows命令行命令执行dos命令
    fprintf('%s %s\r\n','Calculating ',FILENAME{1,file});
    subps1=ps;subps2=ps/5;
    for round=1:1
        pflag=0;
        AP=[];AF=[]; AV=[];AFit=[];AFlag=[];
        
        %population 1 execute CCSPEA2
        [p_chrom1,w_chrom1,f_chrom1]=HInitial(subps1);
        fitness1=zeros(subps1,3);
        NFEs=0;
        for i=1:subps1
            [fitness1(i,1),fitness1(i,2),fitness1(i,3)]=FitDHWSP(p_chrom1(i,:),w_chrom1(i,:,:),f_chrom1(i,:));
        end 
        
        %population 2 execute SPEA2
        [p_chrom2,w_chrom2,f_chrom2]=HInitial(subps2);
        fitness2=zeros(subps2,3);
        NFEs=0;
        for i=1:subps2
           [fitness2(i,1),fitness2(i,2),fitness2(i,3)]=FitDHWSP(p_chrom2(i,:),w_chrom2(i,:,:),f_chrom2(i,:));
        end 
        
        
        i=1;
        QTable1=zeros(10,5);
        CS1=1;      
        while NFEs<MaxNFEs %transfer
        fprintf('%s %s %d %s %d\r\n',FILENAME{1,file},'round',round,'iter',i);
        i=i+1;
        
        %population 1 execute MOCSO
        [CP1,CV1,CF1,CFit1]=MOCSO(p_chrom1,w_chrom1,f_chrom1,fitness1,Pc,Pm,subps1);
        NFEs=NFEs+ps;
		
        %population 2 execute QL-based CS
        [PF1,~]=pareto1(p_chrom2);
        L=length(PF1);
        for k=1:L
            if rand>epsilon
                R=ceil(rand*5);
            else
                [~,Ac]=max(QTable1(CS1,:));
                acl=length(Ac);
                if acl>1
                    R=Ac(ceil(rand*acl));
                else
                    R=Ac;
                end
            end      
            if R==1
               ID=1;
            elseif R==2
               ID=2;
            elseif R==3
               ID=3;
            elseif R==4
               ID=4;
            elseif R==5
               ID=5;
            end     
            j=PF1(k);
            [p_chrom2(j,:),w_chrom2(j,:,:),f_chrom2(j,:),fitness2(j,:),flag1]=QLVNS(p_chrom2(j,:),w_chrom2(j,:,:),f_chrom2(j,:),fitness2(j,:),ID);
            NFEs=NFEs+1;
            if flag1==0
                reward1=10;
            else
                reward1=0;
            end
            NS1=R*2-1+flag1;
            maxreward=max(QTable1(NS1,:));%找到下一状态最大的回报 表示所有的动作都是可能的动作
            Qtarget=reward1+gamma*maxreward;   %计算Q下一个状态的估计值
            QTable1(CS1,R)=QTable1(CS1,R)+alpha*(Qtarget- QTable1(CS1,R));%更新Q矩阵
            CS1=NS1;
         end
%         [CP2,CV2,CF2,CFit2]=CCEA_SPEA2(p_chrom2,v_chrom2,f_chrom2,fitness2,Pc,Pm,subps2);           
         CP2=p_chrom2;CV2=w_chrom2;CF2=f_chrom2;CFit2=fitness2;
        
         if NFEs>0.7*MaxNFEs&&pflag==1
            pflag=2;
        end
        if pflag==0
            if NFEs>0.05*MaxNFEs
                obj1=fitness1(:,1:2);
                obj2=fitness2(:,1:2);
                fig=figure('visible','off');
                plot(obj1(:,1),obj1(:,2),'o','MarkerSize',6,'MarkerFaceColor','r','MarkerEdgeColor','k');
                hold on
                plot(obj2(:,1),obj2(:,2),'d','MarkerSize',6,'MarkerFaceColor','b','MarkerEdgeColor','c');
                hold off
                title(FILENAME{file},'FontName','Bookman Old Style','FontSize',14);
                set(gca,'FontName','Times New Roman','FontSize',13);
                xlabel('Cmax','FontName','Bookman Old Style','FontSize',14);
                ylabel('TEC','FontName','Bookman Old Style','FontSize',14);
                h=legend('task1','task2','Location','northeast');
                set(h,'FontName','Bookman Old Style','FontSize',10);
                cuvname=[FILENAME{file},'1.png'];
                saveas(fig,cuvname);
                pflag=1;
            end
        end
        
        if pflag==2
            if NFEs>0.5*MaxNFEs
                obj1=fitness1(:,1:2);
                obj2=fitness2(:,1:2);
                fig=figure('visible','off');
                plot(obj1(:,1),obj1(:,2),'o','MarkerSize',6,'MarkerFaceColor','r','MarkerEdgeColor','k');
                hold on
                plot(obj2(:,1),obj2(:,2),'d','MarkerSize',6,'MarkerFaceColor','b','MarkerEdgeColor','c');
                hold off
                title(FILENAME{file},'FontName','Bookman Old Style','FontSize',14);
                set(gca,'FontName','Times New Roman','FontSize',13);
                xlabel('Cmax','FontName','Bookman Old Style','FontSize',14);
                ylabel('TEC','FontName','Bookman Old Style','FontSize',14);
                h=legend('task1','task2','Location','northeast');
                set(h,'FontName','Bookman Old Style','FontSize',10);
                cuvname=[FILENAME{file},'2.png'];
                saveas(fig,cuvname);
                pflag=3;
            end
        end
         
        %for task1
        [p_chrom1,w_chrom1,f_chrom1,fitness1,~] = EnSelection1([CP1;CP2],[CV1;CV2],[CF1;CF2],[CFit1;CFit2],subps1);
    
        
        %for task2
        [p_chrom2,w_chrom2,f_chrom2,fitness2,~] = EnSelection1([CP2;CP1],[CV2;CV1],[CF2;CF1],[CFit2;CFit1],subps2);  
        
        %elite strategy
        QP=[p_chrom1;p_chrom2];
        QV=[w_chrom1;w_chrom2];
        QF=[f_chrom1;f_chrom2];
        QFit=[fitness1;fitness2];
        
        
        [PF,~]=pareto1(QFit);
        AP=[AP;QP(PF,:)];AF=[AF;QF(PF,:)];   
        AV=[AV;QV(PF,:,:)];AFit=[AFit;QFit(PF,:)];AFlag=[AFlag;zeros(length(PF),1)];
        [PF,~]=pareto1(AFit);
        AP=AP(PF,:);AFit=AFit(PF,:);AV=AV(PF,:,:);AF=AF(PF,:);AFlag=AFlag(PF,:);
        DeleteRpeat2();
        
        %elite local search
        al=size(AP,1);
        for j=1:al
            R=ceil(rand*5);
            if R==1
               LocalSearch(AP(j,:),AV(j,:,:),AF(j,:),AFit(j,:),1);
            elseif R==2
               LocalSearch(AP(j,:),AV(j,:,:),AF(j,:),AFit(j,:),2);
            elseif R==3
               LocalSearch(AP(j,:),AV(j,:,:),AF(j,:),AFit(j,:),3);
            elseif R==4
               LocalSearch(AP(j,:),AV(j,:,:),AF(j,:),AFit(j,:),4);
            elseif R==5
               LocalSearch(AP(j,:),AV(j,:,:),AF(j,:),AFit(j,:),5);
            end        
            NFEs=NFEs+1;
        end
        [PF,~]=pareto1(AFit);
        AP=AP(PF,:);AFit=AFit(PF,:);AV=AV(PF,:,:);AF=AF(PF,:);AFlag=AFlag(PF,:);
        %write population
        if mod(i,5)==0
            [PF,~]=pareto1(AFit);
            L=length(PF);
            obj=AFit(:,1:2);
            newobj=[];
            for ii=1:L
                newobj(ii,:)=obj(PF(ii),:);
            end
            newobj=unique(newobj,'rows');%删除重复行
            tmp5=newobj';%将求得的前沿解集转置
            %scatter(newobj(:,1),newobj(:,2));
            tmp1='gen';%根据字符串编写出结果存储的路径
            resPATH=[respath tmp1 num2str(i) '.txt'];
            fout=fopen(resPATH,'w');
            fprintf(fout,'%5.2f %6.3f\r\n',tmp5);%由于matlab是按照列存储和读取矩阵，则写入文件的时候也是按照列填写，因此要转置存入
            fclose(fout);
        end
        
        
        end%WHILE END
        obj1=fitness1(:,1:2);
        obj2=fitness2(:,1:2);
        fig=figure('visible','off');
        plot(obj1(:,1),obj1(:,2),'o','MarkerSize',6,'MarkerFaceColor','r','MarkerEdgeColor','k');
        hold on
        plot(obj2(:,1),obj2(:,2),'d','MarkerSize',6,'MarkerFaceColor','b','MarkerEdgeColor','c');
        hold off
        title(FILENAME{file},'FontName','Bookman Old Style','FontSize',14);
        set(gca,'FontName','Times New Roman','FontSize',13);
        xlabel('Cmax','FontName','Bookman Old Style','FontSize',14);
        ylabel('TEC','FontName','Bookman Old Style','FontSize',14);
        h=legend('task1','task2','Location','northeast');
        set(h,'FontName','Bookman Old Style','FontSize',10);
        cuvname=[FILENAME{file},'3.png'];
        saveas(fig,cuvname);
        pflag=1;
        
    [PF,~]=pareto1(AFit);
    L=length(PF);
    obj=AFit(:,1:2);
    newobj=[];
    for i=1:L
        newobj(i,:)=obj(PF(i),:);   
    end
    newobj=unique(newobj,'rows');%删除重复行
    tmp5=newobj';%将求得的前沿解集转置
    %scatter(newobj(:,1),newobj(:,2));
    tmp1='res';%根据字符串编写出结果存储的路径
    resPATH=[respath tmp1 num2str(round) '.txt'];
    fout=fopen(resPATH,'w');
    fprintf(fout,'%5.2f %6.3f\r\n',tmp5);%由于matlab是按照列存储和读取矩阵，则写入文件的时候也是按照列填写，因此要转置存入
    fclose(fout);
   end

end

